#version 150

in vec3 Position;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;

out float vertexDistance;
out mat4 ProjInv;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
    ProjInv = inverse(ProjMat * ModelViewMat);
    vertexDistance = length((ModelViewMat * vec4(Position, 1.0)).xyz);
}
